#include <bits/stdc++.h>

//#pragma GCC optimize("O3")
//#define int long long

using namespace std;

#define rep(i, a, b) for(int i = a; i < (b); ++i)
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()
typedef long long ll;
typedef pair<int,int> pii;
typedef vector<int> vi;

signed main(){
	cin.tie(0);
	ios::sync_with_stdio(0);
	int n;
	cin >> n;
	vector<string> f(n);
	for(auto &t : f) cin >> t;
	vector<int> given(n); // 0: none, 1: only F, 2: only S, 3: both
	vector<int> adjF(n), adjS(n);
	for(int i = 0; i < n; i++){
		for(int j = 0; j < n; j++){
			if(f[i][j] == 'F'){
				adjF[i] |= (1<<j);
				if(given[i] == 2 || given[i] == 3) given[i] = 3;
				else given[i] = 1;
			}
			if(f[i][j] == 'S'){
				adjS[i] |= (1<<j);
				if(given[i] == 1 || given[i] == 3) given[i] = 3;
				else given[i] = 2;
			}
		}
	}
	for(int i = 0; i < (1<<n); i++){
		int num = __builtin_popcount(i);
		if(2*num > (3*n+3)/4 || (n-num) > (3*n+3)/4+1) continue;
		int have = 0;
		for(int j = 0; j < n; j++) if(i&(1<<j)){
			if(given[j] == 3) have = 3;
			else if(given[j] == 2){
				if(have == 1 || have == 3) have = 3;
				else have = 2;
			} else if(given[j] == 1){
				if(have == 2 || have == 3) have = 3;
				else have = 1;
			}
		}
		if(have == 3) continue;
		int inv = ((1<<n)-1)^i;
		int Fok = 1, Sok = 1;
		for(int j = 0; j < n; j++) if(inv&(1<<j)){
			if(adjF[j]&inv) Fok = 0;
			if(adjS[j]&inv) Sok = 0;
		}
		char R;
		if(have == 2){
			R = 'S';
			if(!Sok) continue;
		} else if(have == 1){
			R = 'F';
			if(!Fok) continue;
		}
		else{
			if(Fok) R = 'F';
			else if(Sok) R = 'S';
			else continue;
		}
		char NR;
		if(R == 'F') NR = 'S';
		else NR = 'F';
		for(int j = 0; j < n; j++){
			for(int k = 0; k < n; k++){
				if(j == k) cout << '.';
				else if((inv&(1<<j)) && (inv&(1<<k))) cout << NR;
				else cout << R;
			}
			cout << "\n";
		}
		return 0;
	}
	for(int i = 0; i < (1<<n); i++){
		int num = __builtin_popcount(i);
		if(2*num > (3*n+3)/4 || (n-num) > (3*n+3)/4+1) continue;
		int Fok = 1, Sok = 1;
		for(int j = 0; j < n; j++) if(i&(1<<j)){
			if(adjF[j]&i) Sok = 0;
			if(adjS[j]&i) Fok = 0;
		}
		int inv = ((1<<n)-1)^i;
		for(int j = 0; j < n; j++) if(inv&(1<<j)){
			if(adjF[j]&inv) Sok = 0;
			if(adjS[j]&inv) Fok = 0;
		}
		if(!Sok && !Fok) continue;
		int Skk = 1, Fkk = 1;
		for(int j = 0; j < n; j++) if(i&(1<<j)){
			if(adjF[j]&inv) Fkk = 0;
			if(adjS[j]&inv) Skk = 0;
		}
		for(int j = 0; j < n; j++) if(inv&(1<<j)){
			if(adjF[j]&i) Fkk = 0;
			if(adjS[j]&i) Skk = 0;
		}
		if(!Skk && !Fkk) continue;
		char R;
		if(Fkk && Fok) R = 'S';
		else if(Skk && Sok) R = 'F';
		else continue;
		char NR;
		if(R == 'F') NR = 'S';
		else NR = 'F';
		for(int j = 0; j < n; j++){
			for(int k = 0; k < n; k++){
				if(j == k) cout << '.';
				else if((inv&(1<<j)) && (inv&(1<<k))) cout << NR;
				else if((i&(1<<j)) && (i&(1<<k))) cout << NR;
				else cout << R;
			}
			cout << "\n";
		}
		return 0;
	}

	assert(false);
}
