#include <bits/stdc++.h>

//#pragma GCC optimize("O3")
//#define int long long

using namespace std;

#define rep(i, a, b) for(int i = a; i < (b); ++i)
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()
typedef long long ll;
typedef pair<int,int> pii;
typedef vector<int> vi;

vector<vector<int>> vis, visited;
vector<pair<int,int>> path;
int r, c;
vector<string> starting, ending;
pair<int, int> dfs2(int i, int j) {
	vis[i][j] = true;
	for (int di = -1; di <= +1; ++di)
		for (int dj = -1; dj <= +1; ++dj)
			if (abs(di) + abs(dj) == 1) {
				int ni = i + di;
				int nj = j + dj;
				if (ni >= 0 && ni < r && nj >= 0 && nj < c) {
					if (!vis[ni][nj] && starting[ni][nj] == '*') {
						return dfs2(ni, nj);
					}
				}
			}
	return {i, j};
};
bool dfs(int i, int j) {
	path.push_back({i, j});
	if (starting[i][j] == '*') return true;
	visited[i][j] = true;
	for (int di = -1; di <= +1; ++di)
		for (int dj = -1; dj <= +1; ++dj)
			if (abs(di) + abs(dj) == 1) {
				int ni = i + di;
				int nj = j + dj;
				if (ni >= 0 && ni < r && nj >= 0 && nj < c) {
					if (!visited[ni][nj] && starting[ni][nj] != 'X') {
						if(dfs(ni, nj)) return true;
					}
				}
			}
	path.pop_back();
	return false;
};
int cnts = 0;
void dfs3(int i, int j) {
	cnts += starting[i][j] == '*';
	visited[i][j] = true;
	for (int di = -1; di <= +1; ++di)
		for (int dj = -1; dj <= +1; ++dj)
			if (abs(di) + abs(dj) == 1) {
				int ni = i + di;
				int nj = j + dj;
				if (ni >= 0 && ni < r && nj >= 0 && nj < c) {
					if (!visited[ni][nj] && starting[ni][nj] == '*') {
						dfs3(ni, nj);
					}
				}
			}
};

int sz = 0;
int sz1 = 0;
int sz2 = 0;

void createBlob1(int i, int j) {
	if (starting[i][j] == '.') {
		++sz1;
		starting[i][j] = '*';
	}
	if (sz1 == sz) return;
	for (int di = -1; di <= +1; ++di)
		for (int dj = -1; dj <= +1; ++dj)
			if (abs(di) + abs(dj) == 1) {
				int ni = i + di;
				int nj = j + dj;
				if (ni >= 0 && ni < r && nj >= 0 && nj < c) {
					if (starting[ni][nj] != 'X' && starting[ni][nj] != '*') {
						createBlob1(ni, nj);
					}
					if (sz1 == sz) return;
				}
			}
};
void createBlob2(int i, int j) {
	if (ending[i][j] == '.') {
		++sz2;
		ending[i][j] = '*';
	}
	if (sz2 == sz) return;
	for (int di = -1; di <= +1; ++di)
		for (int dj = -1; dj <= +1; ++dj)
			if (abs(di) + abs(dj) == 1) {
				int ni = i + di;
				int nj = j + dj;
				if (ni >= 0 && ni < r && nj >= 0 && nj < c) {
					if (starting[ni][nj] != 'X' && ending[ni][nj] != '*') {
						createBlob2(ni, nj);
					}
					if (sz2 == sz) return;
				}
			}
};
int total_cnt = 0;
signed main(){
	cin.tie(0);
	ios::sync_with_stdio(0);
	while (1) {
	vector<vector<int>> moves;
	total_cnt = 0;

	vis = vector<vector<int>>();
	visited = vector<vector<int>>();
	path = vector<pair<int,int>>();
//	string emp;
//	getline(cin, emp);
//	stringstream ss(emp);
//	ss >> r >> c;
//	starting = vector<string>(r);
//	ending = vector<string>(r);
//	for (string& s : starting) getline(cin, s);
//	getline(cin, emp);
//	for (string& s : ending) getline(cin, s);

	r = 5;
	c = 5;
	sz = 5;
	sz1 = 0;
	sz2 = 0;
	starting = vector<string>(r, string(c, '.'));
	ending = vector<string>(r, string(c, '.'));

	for (int i = 0; i < r; ++i)
		for (int j = 0; j < c; ++j)
			if (rand() % 1000 == 1) {
				starting[i][j] = ending[i][j] = 'X';
			} else starting[i][j] = ending[i][j] = '.';

	while (1) {
		int xx = rand() % r;
		int yy = rand() % c;
		if (starting[xx][yy] == 'X') continue;
		createBlob1(xx, yy);
		break;
	}

	while (1) {
		int xx = rand() % r;
		int yy = rand() % c;
		if (starting[xx][yy] == 'X') continue;
		createBlob2(xx, yy);
		break;
	}
	for (int i = 0; i < r; ++i)
		cerr << starting[i] << '\n';
	cerr << endl;
	for (int i = 0; i < r; ++i)
		cerr << ending[i] << '\n';
	cerr << endl;

	for (int i = 0; i < r; ++i)
		for (int j = 0; j < c; ++j)
			total_cnt += starting[i][j] == '*';
	auto equal = [&] () {
		for (int i = 0; i < r; ++i)
			for (int j = 0; j < c; ++j)
				if (starting[i][j] == '*' && ending[i][j] != '*')
					return false;
		return true;
	};
	auto prnt = [&] () {
		for (int i = 0; i < r; ++i, cout << '\n')
			for (int j = 0; j < c; ++j)
				cerr << starting[i][j];
		cerr << endl;
	};
	bool overlap = false;
	for (int i = 0; i < r; ++i)
		for (int j = 0; j < c; ++j)
			if (starting[i][j] == '*' && ending[i][j] == '*')
				overlap = true;
	if (!overlap) {
		pair<int, int> s;
		for (int i = 0; i < r; ++i)
			for (int j = 0; j < c; ++j)
				if (ending[i][j] == '*')
					s = {i, j};
		visited = vector<vector<int>>(r, vector<int>(c));
		if (!dfs(s.first, s.second)) {
			cout << "NO\n";
			return 0;
		}
	}
	auto add_move = [&] (int a, int b, int u, int v) {
//		cerr << a << ' ' << b << ' ' << c << ' ' << d << endl;
		starting[a][b] = '.';
		starting[u][v] = '*';
		moves.push_back(vector<int>{a, b, u, v});
		visited = vector<vector<int>>(r, vector<int>(c));
		cnts = 0;
		dfs3(u,v);
		assert(cnts == total_cnt);
	};
	prnt();
	cerr << "hello" << endl;
	while (path.size() > 1) {
//		cerr << path.back().first << ' ' << path.back().second << endl;
		vis = vector<vector<int>>(r, vector<int>(c));
		pair<int, int> lst = dfs2(path.back().first, path.back().second);
//		cerr << lst.first << ' ' << lst.second << endl;
		path.pop_back();
//		cerr << path.back().first << ' ' << path.back().second << endl;
		prnt();
		add_move(lst.first, lst.second, path.back().first, path.back().second);
		prnt();
		if (ending[path.back().first][path.back().second] == '*') break;
		prnt();
		// check connected perhaps?
	}
	while (!equal()) {
		vector<vector<int>> dists(r, vector<int>(c, -1));
		queue<pair<int, int>> q;
		for (int i = 0; i < r; ++i)
			for (int j = 0; j < c; ++j)
				if (starting[i][j] == '*' && ending[i][j] == '*') {
					dists[i][j] = 0;
					q.push({i, j});
				}
		pair<int, int> rmv, add;
		bool set_add = false, set_rmv = false;
		while (q.size()) {
			auto [x, y] = q.front(); q.pop();
			rmv = {x, y};
			set_rmv = true;
			for (int di = -1; di <= +1; ++di)
				for (int dj = -1; dj <= +1; ++dj)
					if (abs(di) + abs(dj) == 1) {
						int ni = x + di;
						int nj = y + dj;
						if (ni >= 0 && ni < r && nj >= 0 && nj < c) {
							if (dists[ni][nj] == -1 && starting[ni][nj] == '*') {
								dists[ni][nj] = dists[x][y] + 1;
								q.push({ni, nj});
							}
							if (starting[ni][nj] == '.' && ending[ni][nj] == '*' && dists[x][y] == 0) {
								add = {ni, nj};
								set_add = true;
							}
						}
					}
		}
		assert(set_add);
		assert(set_rmv);
		assert(add != rmv);
		cerr << "hellox" << endl;
		add_move(rmv.first, rmv.second, add.first, add.second);
		prnt();
	}
	cout << "YES\n";
	cout << moves.size() << '\n';
	for (auto& vec : moves) {
		for (int v : vec) cout << v + 1 << ' ';
		cout << '\n';
	}
	}
	return 0;
}
